﻿// <copyright file="Backlinks.cs" company="Ucaya">
// </copyright>
// <author>Ucaya</author>

namespace MediaRss
{
    #region

    using System.Collections.Generic;
    using System.Xml;
    using System.Xml.Linq;
    using System.Xml.Serialization;

    #endregion

    [XmlRoot(ElementName = "backLinks", Namespace = "http://search.yahoo.com/mrss/")]
    public class Backlinks : MediaRssBase, IXmlSerializable
    {
        #region Constants and Fields

        internal const string ELEMENT_NAME = "backLinks";

        #endregion

        #region Public Properties

        public List<Backlink> BacklinkItems { get; set; }

        #endregion

        #region Public Methods

        public void ReadXml(XmlReader reader)
        {
            bool isEmptyElement = reader.IsEmptyElement;
            base.AddAttributeExtensions(reader);
            reader.ReadStartElement();
            if (!isEmptyElement)
            {
                while (reader.IsStartElement())
                {
                    if (reader.LocalName == "backLink")
                    {
                        if (this.BacklinkItems == null)
                        {
                            this.BacklinkItems = new List<Backlink>();
                        }
                        var item = new Backlink();
                        item.ReadXml(reader);
                        this.BacklinkItems.Add(item);
                    }
                    else
                    {
                        base.ElementExtensions.Add((XElement)XNode.ReadFrom(reader));
                    }
                }
            }
            reader.ReadEndElement();
        }

        public void WriteXml(XmlWriter writer)
        {
            foreach (var pair in base.AttributeExtensions)
            {
                writer.WriteAttributeString(pair.Key.Name, pair.Key.Namespace, pair.Value);
            }
            if ((this.BacklinkItems != null) && (this.BacklinkItems.Count > 0))
            {
                foreach (var backlink in this.BacklinkItems)
                {
                    backlink.WriteXml(writer);
                }
            }
            foreach (var element in base.ElementExtensions)
            {
                element.WriteTo(writer);
            }
        }

        #endregion
    }
}