﻿// <copyright file="Comments.cs" company="Ucaya">
// </copyright>
// <author>Ucaya</author>

namespace MediaRss
{
    #region

    using System.Collections.Generic;
    using System.Xml;
    using System.Xml.Linq;
    using System.Xml.Serialization;

    #endregion

    [XmlRoot(ElementName = "comments", Namespace = "http://search.yahoo.com/mrss/")]
    public class Comments : MediaRssBase, IXmlSerializable
    {
        #region Constants and Fields

        internal const string ELEMENT_NAME = "comments";

        #endregion

        #region Public Properties

        public List<Comment> CommentItems { get; set; }

        #endregion

        #region Public Methods

        public void ReadXml(XmlReader reader)
        {
            bool isEmptyElement = reader.IsEmptyElement;
            base.AddAttributeExtensions(reader);
            reader.ReadStartElement();
            if (!isEmptyElement)
            {
                while (reader.IsStartElement())
                {
                    if (reader.LocalName == "comment")
                    {
                        if (this.CommentItems == null)
                        {
                            this.CommentItems = new List<Comment>();
                        }
                        var item = new Comment();
                        item.ReadXml(reader);
                        this.CommentItems.Add(item);
                    }
                    else
                    {
                        base.ElementExtensions.Add((XElement)XNode.ReadFrom(reader));
                    }
                }
            }
            reader.ReadEndElement();
        }

        public void WriteXml(XmlWriter writer)
        {
            foreach (var pair in base.AttributeExtensions)
            {
                writer.WriteAttributeString(pair.Key.Name, pair.Key.Namespace, pair.Value);
            }
            if ((this.CommentItems != null) && (this.CommentItems.Count > 0))
            {
                foreach (var comment in this.CommentItems)
                {
                    comment.WriteXml(writer);
                }
            }
            foreach (var element in base.ElementExtensions)
            {
                element.WriteTo(writer);
            }
        }

        #endregion
    }
}