﻿// <copyright file="Contents.cs" company="Ucaya">
// </copyright>
// <author>Ucaya</author>

namespace MediaRss
{
    #region

    using System.Collections.Generic;
    using System.Xml;
    using System.Xml.Linq;
    using System.Xml.Serialization;

    #endregion

    [XmlRoot(ElementName = "group", Namespace = "http://search.yahoo.com/mrss/")]
    public class Contents : MediaRssBase, IXmlSerializable
    {
        #region Constants and Fields

        internal const string ELEMENT_NAME = "group";

        #endregion

        #region Public Properties

        public List<Content> ContentsItems { get; set; }

        #endregion

        #region Public Methods

        public void ReadXml(XmlReader reader)
        {
            bool isEmptyElement = reader.IsEmptyElement;
            base.AddAttributeExtensions(reader);
            reader.ReadStartElement();
            if (!isEmptyElement)
            {
                while (reader.IsStartElement())
                {
                    if (reader.LocalName == "content")
                    {
                        if (this.ContentsItems == null)
                        {
                            this.ContentsItems = new List<Content>();
                        }
                        var item = new Content();
                        item.ReadXml(reader);
                        this.ContentsItems.Add(item);
                    }
                    else
                    {
                        base.ElementExtensions.Add((XElement)XNode.ReadFrom(reader));
                    }
                }
            }
            reader.ReadEndElement();
        }

        public void WriteXml(XmlWriter writer)
        {
            foreach (var pair in base.AttributeExtensions)
            {
                writer.WriteAttributeString(pair.Key.Name, pair.Key.Namespace, pair.Value);
            }
            if ((this.ContentsItems != null) && (this.ContentsItems.Count > 0))
            {
                foreach (var backlink in this.ContentsItems)
                {
                    backlink.WriteXml(writer);
                }
            }
            foreach (var element in base.ElementExtensions)
            {
                element.WriteTo(writer);
            }
        }

        #endregion
    }
}