﻿// <copyright file="Statistics.cs" company="Ucaya">
// </copyright>
// <author>Ucaya</author>

namespace MediaRss
{
    #region

    using System.Xml;
    using System.Xml.Serialization;

    #endregion

    [XmlRoot(ElementName = "statistics", Namespace = "http://search.yahoo.com/mrss/")]
    public class Statistics : MediaRssBase, IXmlSerializable
    {
        #region Constants and Fields

        internal const string ELEMENT_NAME = "statistics";

        #endregion

        #region Public Properties

        public int Favorites { get; set; }

        public int Views { get; set; }

        #endregion

        #region Public Methods

        public void ReadXml(XmlReader reader)
        {
            bool isEmptyElement = reader.IsEmptyElement;
            if (reader.HasAttributes)
            {
                for (int i = 0; i < reader.AttributeCount; i++)
                {
                    reader.MoveToNextAttribute();
                    if (reader.NamespaceURI == "")
                    {
                        string localName = reader.LocalName;
                        if (localName == null)
                        {
                            goto Label_008E;
                        }
                        if (!(localName == "views"))
                        {
                            if (localName == "favorites")
                            {
                                goto Label_007A;
                            }
                            goto Label_008E;
                        }
                        this.Views = int.Parse(reader.Value);
                    }
                    goto Label_00B4;
                    Label_007A:
                    this.Favorites = int.Parse(reader.Value);
                    goto Label_00B4;
                    Label_008E:
                    base.AttributeExtensions.Add(new XmlQualifiedName(reader.LocalName, reader.NamespaceURI), reader.Value);
                    Label_00B4:
                    ;
                }
            }
            reader.ReadStartElement();
            base.AddElementExtensions(reader, isEmptyElement);
        }

        public void WriteXml(XmlWriter writer)
        {
            writer.WriteStartElement("media", "statistics", "http://search.yahoo.com/mrss/");
            writer.WriteAttributeString("views", null, this.Views.ToString());
            writer.WriteAttributeString("favorites", null, this.Favorites.ToString());
            foreach (var pair in base.AttributeExtensions)
            {
                writer.WriteAttributeString(pair.Key.Name, pair.Key.Namespace, pair.Value);
            }
            writer.WriteEndElement();
            foreach (var element in base.ElementExtensions)
            {
                element.WriteTo(writer);
            }
        }

        #endregion
    }
}