﻿// <copyright file="Thumbnails.cs" company="Ucaya">
// </copyright>
// <author>Ucaya</author>

namespace MediaRss
{
    #region

    using System.Collections.Generic;
    using System.Xml;
    using System.Xml.Linq;
    using System.Xml.Serialization;

    #endregion

    [XmlRoot(ElementName = "thumbnails", Namespace = "http://search.yahoo.com/mrss/")]
    public class Thumbnails : MediaRssBase, IXmlSerializable
    {
        #region Constants and Fields

        internal const string ELEMENT_NAME = "thumbnails";

        #endregion

        #region Public Properties

        public List<Thumbnail> ThumbnailsItems { get; set; }

        #endregion

        #region Public Methods

        public void ReadXml(XmlReader reader)
        {
            bool isEmptyElement = reader.IsEmptyElement;
            base.AddAttributeExtensions(reader);
            reader.ReadStartElement();
            if (!isEmptyElement)
            {
                while (reader.IsStartElement())
                {
                    if (reader.LocalName == "thumbnail")
                    {
                        if (this.ThumbnailsItems == null)
                        {
                            this.ThumbnailsItems = new List<Thumbnail>();
                        }
                        var item = new Thumbnail();
                        item.ReadXml(reader);
                        this.ThumbnailsItems.Add(item);
                    }
                    else
                    {
                        base.ElementExtensions.Add((XElement)XNode.ReadFrom(reader));
                    }
                }
            }
            reader.ReadEndElement();
        }

        public void WriteXml(XmlWriter writer)
        {
            foreach (var pair in base.AttributeExtensions)
            {
                writer.WriteAttributeString(pair.Key.Name, pair.Key.Namespace, pair.Value);
            }
            if ((this.ThumbnailsItems != null) && (this.ThumbnailsItems.Count > 0))
            {
                foreach (var backlink in this.ThumbnailsItems)
                {
                    backlink.WriteXml(writer);
                }
            }
            foreach (var element in base.ElementExtensions)
            {
                element.WriteTo(writer);
            }
        }

        #endregion
    }
}