﻿// <copyright file="CursorService.cs" company="Ucaya">
// </copyright>
// <author>Ucaya</author>

namespace KinectExtensions.Services
{
    #region

    using System;
    using System.ComponentModel;
    using System.ComponentModel.Composition;
    using System.Linq.Expressions;

    using KinectExtensions.Nui;

    #endregion

    /// <summary>
    ///   TODO: Update summary.
    /// </summary>
    [Export]
    public class CursorService : INotifyPropertyChanged
    {
        #region Constants and Fields

        /// <summary>
        ///   The cursor provider.
        /// </summary>
        private ICursorProvider cursorProvider;

        #endregion

        #region Public Events

        /// <summary>
        ///   The property changed.
        /// </summary>
        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        #region Public Properties

        /// <summary>
        ///   Gets or sets CursorProvider.
        /// </summary>
        public ICursorProvider CursorProvider
        {
            get
            {
                return this.cursorProvider;
            }

            set
            {
                if (this.cursorProvider != value)
                {
                    this.cursorProvider = value;
                    this.RaisePropertyChanged(n => n.CursorProvider);
                }
            }
        }

        #endregion

        #region Methods

        /// <summary>
        ///   The raise property changed.
        /// </summary>
        /// <param name = "expression">
        ///   The expression.
        /// </param>
        /// <typeparam name = "TProperty">
        /// </typeparam>
        protected void RaisePropertyChanged<TProperty>(Expression<Func<CursorService, TProperty>> expression)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(this.GetPropertyName(expression)));
            }
        }

        #endregion
    }
}